<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "waiting_room_queue".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "WaitingRoomQueue".
 *
 * Columns in table "waiting_room_queue" available as properties of the model,
 * followed by relations of table "waiting_room_queue" available as properties of the model.
 *
 * @property integer $id
 * @property integer $waiting_room_invite_id
 * @property string $date_added
 * @property string $date_updated
 * @property string $room_created
 * @property string $room_ended
 * @property string $provider_connected
 * @property string $provider_disconnected
 * @property string $patient_connected
 * @property string $patient_disconnected
 * @property string $room_sid
 * @property integer $room_duration
 *
 * @property WaitingRoomInvite $waitingRoomInvite
 */
abstract class BaseWaitingRoomQueue extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'waiting_room_queue';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'WaitingRoomQueue|WaitingRoomQueues', $n);
    }

    public static function representingColumn()
    {
        return 'date_added';
    }

    public function rules()
    {
        return array(
            array('waiting_room_invite_id, room_duration', 'numerical', 'integerOnly' => true),
            array('room_sid', 'length', 'max' => 34),
            array('date_added, date_updated, room_created, room_ended, provider_connected, provider_disconnected, '
                . 'patient_connected, patient_disconnected', 'safe'),
            array('waiting_room_invite_id, date_added, date_updated, room_created, room_ended, provider_connected, '
                . 'patient_connected, room_sid, room_duration', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, waiting_room_invite_id, date_added, date_updated, room_created, room_ended, provider_connected, '
                . 'patient_connected, room_sid, room_duration', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'waitingRoomInvite' => array(self::BELONGS_TO, 'WaitingRoomInvite', 'waiting_room_invite_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'waiting_room_invite_id' => null,
            'date_added' => Yii::t('app', 'Date Added'),
            'date_updated' => Yii::t('app', 'Date Updated'),
            'room_created' => Yii::t('app', 'Room Created'),
            'room_ended' => Yii::t('app', 'Room Ended'),
            'provider_connected' => Yii::t('app', 'Provider Connected'),
            'provider_disconnected' => Yii::t('app', 'Provider Disconnected'),
            'patient_connected' => Yii::t('app', 'Patient Connected'),
            'patient_discconnected' => Yii::t('app', 'Patient Disconnected'),
            'room_sid' => Yii::t('app', 'Room Sid'),
            'room_duration' => Yii::t('app', 'Room Duration'),
            'waitingRoomInvite' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('waiting_room_invite_id', $this->waiting_room_invite_id);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('date_updated', $this->date_updated, true);
        $criteria->compare('room_created', $this->room_created, true);
        $criteria->compare('room_ended', $this->room_ended, true);
        $criteria->compare('provider_connected', $this->provider_connected, true);
        $criteria->compare('provider_disconnected', $this->provider_disconnected, true);
        $criteria->compare('patient_connected', $this->patient_connected, true);
        $criteria->compare('patient_disconnected', $this->patient_disconnected, true);
        $criteria->compare('room_sid', $this->room_sid, true);
        $criteria->compare('room_duration', $this->room_duration);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

}
